Subject: Re: 2.6.24 BUG: soft lockup - CPU#X

From: Ingo Molnar <[email-masked]>
Date: Fri, 28 Mar 2008 15:12:48 +0100

* Herbert Xu <[email-masked]> wrote:

> I agree that using jiffies is a pretty coarse approximation of proper 
> scheduling.  However, in the absence of a better solution we have to 
> live with it.
> 
> Perhaps running these out of process context is the correct approach.

yes. Such anonymous work loops inside softirq context are a disaster to 
TCP determinism and a disaster to scheduling in general (the wrong guy 
gets credited with the overhead). Softirqs were a neat hack 10 years 
ago, now if we know the target task for some workload we should execute 
as much of the workload in that task's context as possible. (and even 
for stuff where we dont have a 'target task' - routing, filtering, etc. 
- it might be better to use kernel threads.)

	Ingo